import React from 'react';
import { produce } from 'immer';
export function createProvider(Provider, context) {
    /**
     * SrimmerProvider.
     */
    return class SrimmerProvider extends React.Component {
        /**
         * props to state.
         */
        constructor(props) {
            super(props);
            /**
             * state updator.
             */
            this.updateState = (mutator) => {
                this.setState({
                    state: produce(this.state.state, function () {
                        mutator(this);
                    })
                });
            };
            this.state = { state: props.state };
            context.updateState = this.updateState;
        }
        /**
         * render.
         */
        render() {
            return (React.createElement(Provider, { value: this.state.state }, this.props.children));
        }
    };
}
;
//# sourceMappingURL=Provider.js.map